const fs = require('fs')
const Papa = require('papaparse')

const filename = 'fixations.csv'

const csvFile = fs.readFileSync(filename, 'utf8')

const results = Papa.parse(csvFile, {
  header: true,
  dynamicTyping: true
})

const data = results.data

console.log(data[10]['fixation x [px]'])
console.log(data[10]['fixation y [px]'])

console.log(data[15]['fixation x [px]'])
console.log(data[15]['fixation y [px]'])

console.log(data[22]['fixation x [px]'])
console.log(data[22]['fixation y [px]'])

console.log(data[27]['fixation x [px]'])
console.log(data[27]['fixation y [px]'])

console.log(data[33]['fixation x [px]'])
console.log(data[33]['fixation y [px]'])

const gaze_p = [
  [data[10]['fixation x [px]'], data[10]['fixation y [px]']],
  [data[15]['fixation x [px]'], data[15]['fixation y [px]']],
  [data[22]['fixation x [px]'], data[22]['fixation y [px]']],
  [data[27]['fixation x [px]'], data[27]['fixation y [px]']],
  [data[33]['fixation x [px]'], data[33]['fixation y [px]']]
]

const GT_locations = [
  [800, 640],
  [480, 480],
  [480, 800],
  [1120, 480],
  [1120, 800]
]

const X_px = 1600
const Y_px = 1200
const X_deg = 132
const Y_deg = 81

function val_et_accuracy (gaze_p, gaze_gt) {
  let errAcum = 0
  let errDegAcum = 0

  for (let i = 0; i < gaze_p.length; i++) {
    const coord = gaze_p[i]
    const x_err = coord[0] - gaze_gt[i][0]
    const y_err = coord[1] - gaze_gt[i][1]
    const x_err_deg = (x_err / X_px) * X_deg
    const y_err_deg = (y_err / Y_px) * Y_deg

    const err = Math.sqrt(x_err ** 2 + y_err ** 2)
    errAcum += err

    const err_deg = Math.sqrt(x_err_deg ** 2 + y_err_deg ** 2)
    errDegAcum += err_deg
  }

  const avgErr = errAcum / gaze_gt.length
  const avgErrDeg = errDegAcum / gaze_gt.length

  console.log(`err in PX: ${avgErr}`)
  console.log(`err in Deg: ${avgErrDeg}`)

  return [avgErr, avgErrDeg]
}

val_et_accuracy(gaze_p, GT_locations)
