import Graph from 'graphology'
import graphml from 'graphology-graphml'

export default function parseGraph (graphXml) {
  const graph = graphml.parse(Graph, graphXml)

  const nodesUndPlane = graph.mapNodes((node, attributes) => {
    return {
      index: +node,
      x: +attributes.x,
      y: +attributes.y,
      z: +attributes.z
    }
  })
  const nodes = nodesUndPlane.filter(node => Number.isInteger(node.index))

  const links = graph.mapEdges((edge, attributes, source, target) => {
    return {
      source,
      target
    }
  })

  return {
    nodes,
    links: links.map(link => {
      return {
        source: nodes[link.source],
        target: nodes[link.target]
      }
    })
  }
}
