import { defineConfig } from 'vite'
import { resolve } from 'path'
import fs from 'fs-extra'

export default defineConfig({
  base: '/webxr/',
  build: {
    outDir: 'dist',
    rollupOptions: {
      input: {
        main: './index.html',
        replay: './replay/index.html',
        test: './test/index.html',
        fixations: './fixations/index.html',
      }
    }
  },
  plugins: [
    {
      name: 'copy-index-to-routes',
      closeBundle: async () => {

        await fs.ensureDir('dist/1')
        await fs.ensureDir('dist/2')
        await fs.ensureDir('dist/3')
        await fs.ensureDir('dist/4')
        await fs.ensureDir('dist/5')
        await fs.ensureDir('dist/6')
        await fs.ensureDir('dist/7')
        await fs.ensureDir('dist/8')
        await fs.ensureDir('dist/9')
        
        await fs.copyFile('dist/index.html', 'dist/1/index.html')
        await fs.copyFile('dist/index.html', 'dist/2/index.html')
        await fs.copyFile('dist/index.html', 'dist/3/index.html')
        await fs.copyFile('dist/index.html', 'dist/4/index.html')
        await fs.copyFile('dist/index.html', 'dist/5/index.html')
        await fs.copyFile('dist/index.html', 'dist/6/index.html')
        await fs.copyFile('dist/index.html', 'dist/7/index.html')
        await fs.copyFile('dist/index.html', 'dist/8/index.html')
        await fs.copyFile('dist/index.html', 'dist/9/index.html')
        
        console.log('Successfully copied index.html to routes 1 - 9')
      }
    }
  ]
})